import java.awt.*;
import java.io.*;
import java.net.*;
//import com.ms.awt.image.ImageFormatException;

public class AtThumbs extends Canvas implements Runnable
{
	private String thumbServer, thumbRoom;
    private Thread thrd;
    private Toolkit tk;
    private Socket sock;
    private Image img[];
    private Graphics offGraphics;
    private final int MAX_IMAGES = 3;
    private int nSpeed, nImgCnt, nPort, nDataSize, displayFrame;
    private String _cIp, cRoom, cPortal, cVch;
    private OutputStream os;
    private PrintWriter pw;
    private InputStream is;
    private DataInputStream ds;
	protected Rectangle coords;

	AtThumbs(){
	}
		
	AtThumbs(String server){
		thumbServer = server;
		common();
	}
	
	AtThumbs(String server, String room, int x, int y){		
		thumbServer = server;
		thumbRoom = room;
		coords = new Rectangle(x,y,40,30);
		common();
    }
	private void common(){
		tk = Toolkit.getDefaultToolkit();
		img = new Image[MAX_IMAGES];

		nImgCnt = -1;
		nDataSize = 2048;
		nSpeed = 750;

		nPort = (int)(Math.random() * 10D) % 10;
        nPort += 8080;
		displayFrame = 0;
		cVch = null;
	}

	public void setServer (String server){
		thumbServer = server;
	}
	public void setRoom (String room){
		thumbRoom = room;
	}
	public void setCoords (int x, int y){
		coords = new Rectangle(x,y,40,30);
	}
	
	
	public void startFetcher(){
	common();
        if(thrd == null) {
			thrd = new Thread(this,"AtThumbs "+thumbServer+":"+nPort+" Room : "+thumbRoom);
            thrd.start();
        }
	}

    public void run() {
		int j = 0;
        for(int i = 0; i < MAX_IMAGES; i++)
            img[i] = null;
        if(sock != null)
			try {sock.close();}
            catch(Exception _ex) {error(2,_ex);}
        sock = null;
		if (openSocket() && setStreams()){
			if(getVch()) {
				getVids();
				closeSocket();
			}
		}
    }

    private boolean openSocket() {
        int i;
        for(i = 0; thrd != null && sock == null && i < 30; i++)
            try {
                sock = new Socket(thumbServer, nPort);
                if(sock != null)
                    break;
                Thread.sleep(1000L);
            }
            catch(Exception _ex) {
				error(3,_ex);
				return false;
			}

        return i < 30 && sock != null;
    }

    private boolean setStreams() {
        boolean flag = true;
        try {
            os = sock.getOutputStream();
            pw = new PrintWriter(new OutputStreamWriter(os));
            is = sock.getInputStream();
            ds = new DataInputStream(new BufferedInputStream(is));
        }
        catch(Exception _ex) {
			error(4,_ex);
            try {
                sock.close();
                sock = null;
            }
            catch(Exception _ex2) { error(5,_ex2) ;}
            flag = false;
        }
        return flag;
    }

    private synchronized boolean getVch() {
        byte abyte0[] = new byte[nDataSize];
        byte abyte1[] = new byte[nDataSize];
        boolean flag = false;
        boolean flag1 = false;
        if(cVch != null)
            return true;
        if(sock == null)
            return false;
        if(thrd == null)
            return false;
        String s = "GET /vch.info?room=" + thumbRoom + "&doc=http://www.ifriends.net/livewebcamviewer/if/index3.htm HTTP/1.0\r\n";
        cVch = null;
        try {
            pw.write(s);
            pw.flush();
            int k = 0;
            int i = is.read(abyte0, k, nDataSize - k);
            k += i;
            if(k > 2) {
                if(abyte0[k - 2] == 13)
                    k -= 2;
                else
                    k--;
                abyte0[k] = 0;
                byte abyte2[] = new byte[k];
                System.arraycopy(abyte0, 0, abyte2, 0, k);
                cVch = new String(abyte2);
                int j = cVch.indexOf('*');
                if(j > 0) {
                    cVch = cVch.substring(0, j);
                    flag1 = true;
                }
            }
        }
        catch(IOException _eio) {
			error(6,_eio);
        }
        return flag1;
    }

    private synchronized void getVids() {
        int k = 0;
        byte abyte0[] = new byte[nDataSize];
        byte abyte1[] = new byte[nDataSize];
        String s = "GET /image.jpg HTTP/1.0\r\n";
        while(thrd != null && sock != null && nImgCnt < 10 && k < MAX_IMAGES)  {
            try {
                pw.write(s);
                pw.flush();
                int j = 0;
                do {
                    int i = is.read(abyte0, j, nDataSize - j);
                    if(i < 0)
                        break;
                    j += i;
                    if(j >= nDataSize) {
                        nDataSize = nDataSize + 1024;
                        byte abyte2[] = new byte[nDataSize];
                        System.arraycopy(abyte0, 0, abyte2, 0, j);
                        abyte0 = abyte2;
                        abyte2 = null;
                    }
                } while(abyte0[j - 1] != -39);
                nImgCnt++;
				img[nImgCnt] = tk.createImage(abyte0);
				MediaTracker mediatracker = new MediaTracker(this);
				mediatracker.addImage(img[nImgCnt], 1);
				mediatracker.waitForID(1);
                k++;
            }
            catch(Exception _ex) {
				error(8,_ex);
                return;
            }
            try {
                Thread.sleep(nSpeed);
            }
            catch(Exception _ex) { error(9,_ex);}
        }
    }

    private void closeSocket() {
        if(sock == null)
            return;
        try {
            is.close();
            sock.close();
        }
        catch(Exception _ex) {error(11,_ex); }
        sock = null;
    }
	
	private void error(int a, Exception e){
		if (a!=8)
			System.out.println("Error : AtThumbs "+thumbServer+" "+thumbRoom+" @ : "+a+" : "+e);
	}
	
	private int lastFrame = 0, currentFrame = 0, futureFrame = 0;
	
	public Image getFrame(){
		futureFrame = lastFrame + 1;
		if (futureFrame>=img.length)
			futureFrame=0;
		if (img[futureFrame]!=null){
			currentFrame = futureFrame;
			lastFrame = futureFrame;
			futureFrame++;
			return img[currentFrame];
		} else return img[lastFrame];
	}
	
	public String getChannel(){
		return cVch;
	}
	
    public void stop() {
		if(thrd != null){
			thrd.stop();
            thrd = null;
		}
        if(sock != null) {
            try {
                sock.close();
            }
            catch(Exception _ex) {error(1,_ex);}
            sock = null;
        }
		for (int a=0;a<img.length;a++){
			if (img[a]!=null)
				img[a]=null;
		}
    }	
}